#include <stdio.h>

#include "innova.h"

static char *plug_desc="plugin description";

char *get_io_desc(int *pv)
{
	*pv =PLUGIN_FORMAT;
	innova_p(INFO, "get_io_desc, return; [%s]\n", plug_desc);

	return plug_desc;
}

int mangle_init(struct innova_struct *is)
{
	innova_p(INFO, "mangle_init\n");

	/*
	 * return < 0 is error, and innova is break,
	 * return 0 is for repeat mangle_init,
	 * return > 0 is for init success, innova continue happy
	 */
	return 1;
}

int mangle_cleanup(struct innova_struct *is, int error)
{
	innova_p(INFO, "mangle_cleanup, error %d\n", error);

	return -1;
}

int local_mangle(struct innova_struct *is, struct innova_packet *pkt)
{
	if(pkt->tcp !=NULL)
		innova_p(INFO, "local_mangle: %d: %s %s %s %s (%d)", 
			pkt->ip->id,
			pkt->tcp->syn ? "syn" : "",
			pkt->tcp->ack ? "ack" : "",
			pkt->tcp->fin ? "fin" : "",
			pkt->tcp->rst ? "rst" : "",
			pkt->data_len
				);

	return PACKET_OK;
}

int remote_mangle(struct innova_struct *is, struct innova_packet *pkt)
{
	if(pkt->tcp !=NULL)
		innova_p(INFO, "remote_mangle: %d: %s %s %s %s (%d)", 
			pkt->ip->id,
			pkt->tcp->syn ? "syn" : "",
			pkt->tcp->ack ? "ack" : "",
			pkt->tcp->fin ? "fin" : "",
			pkt->tcp->rst ? "rst" : "",
			pkt->data_len
				);

	return PACKET_OK;
}

int foo_mangle_f(unsigned char hook, struct innova_struct *is, struct innova_packet *pkt, void *x)
{
	switch(hook)
	{
		case INIT_HOOK:
			innova_p(INFO, "foo_mangle_f: INIT_HOOK");
			break;
		case CLEANUP_HOOK:
			innova_p(INFO, "foo_mangle_f: CLEANUP_HOOK");
			break;
		case OPT_PARSE_HOOK:
			innova_p(INFO, "foo_mangle_f: OPT_PARSE_HOOK");
			break;
		case LOCAL_M_HOOK:
			innova_p(INFO, "foo_mangle_f: LOCAL_M_HOOK");
			break;
		case REMOTE_M_HOOK:
			innova_p(INFO, "foo_mangle_f: REMOTE_M_HOOK");
			break;
		case UNKNOW_M_HOOK:
			innova_p(INFO, "foo_mangle_f: UNKNOW_M_HOOK");
			break;
		case TIMEEXC_HOOK:
			innova_p(INFO, "foo_mangle_f: TIMEEXC_HOOK");
			break;
		default:
			innova_p(INFO, "hook %d ??", hook);
	}

	return PACKET_OK;
}

int io_timeexceed(struct innova_struct *is, int *timeout)
{
	innova_p(INFO, "io_timeexceed timeout: 0x%x\n", (unsigned int)timeout);

	return 0x00;
}

int option_parser(struct innova_struct *is, struct innova_options *iopt)
{
	innova_p(INFO, "option_parser: iopt->plug_opt: [%s]\n", iopt->plug_opt);

	return 0x00;
}
